#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <cmath>


using namespace std;
using i64 = long long;


i64 n, m;
vector<i64>a;
vector<i64>t;

int test(i64 time) {
	i64 count_ = 0;
	
	for (i64 i = 0; i < n && count_ < m; i++) {
		if (time >= a[i]) {
			if (time >= a[i] + t[i] ) {
				count_ += pow(2, (time - a[i] - t[i] + 1));;
			}
			else {
				count_++;
			}
		}
	}


	//cout << count_ << " ";
	if (count_ < 0) {
		return 1;
	}
	return count_ > m;
}


pair<i64, i64> bin_search() {
	i64 l = 0;
	i64 r = 1000;
	if (test(0)) {
		return { 0, 0 };
	}
	while (r - l > 1) {
		i64 mid = (l + r) / 2;
		if (test(mid)) {
			r = mid;
		}
		else {
			l = mid;
		}
		//cout << l << " " << mid << " " << r << "\n";
	}

	return { l, r };
}



void solve() {
	cin >> n >> m;
	a.resize(n, 0);
	t.resize(n, 0);

	for (i64 i = 0; i < n; i++) { cin >> a[i]; }
	for (i64 i = 0; i < n; i++) { cin >> t[i]; }

	pair<i64, i64>c = bin_search();
	i64 l = c.first;
	i64 r = c.first;

	i64 count_ = 0;
	i64 time = l;

	for (i64 i = 0; i < n && count_ < m; i++) {
		if (time >= a[i]) {
			if (time >= a[i] + t[i]) {
				count_ += pow(2, (time - a[i] - t[i] + 1));;
			}
			else {
				count_++;
			}
		}
	}

	if (count_ == m) {
		cout << time;
	}
	else {
		cout << -1;
	}
	
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}